
/*
 * Below are several defines needed by the Unix parts of POV.  You
 * may redefine them as needed in this config.h file. Each has a default
 * which will be defined in frame.h if you don't define it here.
 */

/*
 * This should use the standard C header files, if they exist, or just
 * our own prototypes if they don't.  Modify to suit your needs.
 */

//#define PM_POV

#ifdef __STDC__
#define PARAMS(x) x
#  ifndef CONST
#  define CONST const
#  endif
#include <stdlib.h>
#include <unistd.h>
#else
#define PARAMS(x) ()
#  ifndef volatile
#  define volatile
#  endif
#endif


#define COMPILER_VER ".os2.ibm-vacpp30"

#define POV_NAME_MAX 254

#define FILE_NAME_MAX 254

#define FILE_NAME_LENGTH 254

#define FILENAME_SEPARATOR '\\'

#define DRIVE_SEPARATOR ':'

#define NEW_LINE_STRING "\r\n"


#define READ_ENV_VAR           OS2_Process_Env();
#define PROCESS_POVRAY_INI     OS2_Process_Povray_Ini(argv[0]);

void OS2_Process_Env          PARAMS((void));
void OS2_Process_Povray_Ini(char *s);

#define TIME_ELAPSED (tstop - tstart);

#define DEFAULT_OUTPUT_FORMAT  't'

/*
 * What level of memory statistics we want.  See mem.h for more info.
 */
#define MEM_STATS 1


#define PRECISION_TIMER_AVAILABLE 1

#if PRECISION_TIMER_AVAILABLE

#define PRECISION_TIMER_INIT
#define PRECISION_TIMER_START OS2_Timer_Start();
#define PRECISION_TIMER_STOP  OS2_Timer_Stop();
#define PRECISION_TIMER_COUNT OS2_Timer_Count();

void OS2_Timer_Start PARAMS((void));
void OS2_Timer_Stop  PARAMS((void));
int  OS2_Timer_Count PARAMS((void));

#endif /* PRECISION_TIMER_AVAILABLE */


#define POV_PRE_RENDER   OS2_Abort_Start();
#define POV_PRE_SHUTDOWN OS2_Abort_Handler(0);
void OS2_Abort_Start PARAMS((void));
void OS2_Abort_Handler PARAMS((int signum));

#define MAIN_RETURN_TYPE       int
#define MAIN_RETURN_STATEMENT  return 0;




#ifndef PM_POV

#define STARTUP_POVRAY    OS2_init_povray(argc, argv);

void OS2_init_povray PARAMS((int argc, char **argv));

#else

#define STARTUP_POVRAY    OS2_init_povray(argc, argv);
#define FINISH_POVRAY(i)  OS2_finish_povray(i);

void OS2_init_povray PARAMS((int argc, char **argv));
void OS2_finish_povray PARAMS((int status));


#define POV_DISPLAY_INIT(w,h) OS2_Display_Init ((w), (h));
#define POV_DISPLAY_FINISHED OS2_Display_Finished();
#define POV_DISPLAY_CLOSE OS2_Display_Close();
#define POV_DISPLAY_PLOT(x,y,r,g,b,a) OS2_Display_Plot((x),(y),(r),(g),(b));
#define POV_DISPLAY_PLOT_RECT(x1,x2,y1,y2,r,g,b,a) OS2_Display_Plot_Rect((x1),(x2),(y1),(y2),(r),(g),(b));
#define POV_DISPLAY_PLOT_BOX(x1,x2,y1,y2,r,g,b,a) box((x1),(x2),(y1),(y2),(r),(g),(b));

void OS2_Display_Init (int w, int h);
void OS2_Display_Finished (void);
void OS2_Display_Close (void);
void OS2_Display_Plot (int x, int y, unsigned char r, unsigned char g, unsigned char b);
void OS2_Display_Plot_Rect (int x1, int x2, int y1, int y2, unsigned char r, unsigned char g, unsigned char b);
void box (int x1, int x2, int y1, int y2, unsigned int r, unsigned int g, unsigned int b);

#endif



/*
 * This is the render abort function for X Windows.  It is not needed for
 * the command-line interface, since the abort is handled via interrupts.
 */
/*
#define TEST_ABORT Stop_Flag += XWIN_Test_Abort();
int XWIN_Test_Abort PARAMS((void));
*/
