#define INCL_WINWINDOWMGR
#define INCL_WINFRAMEMGR
#define INCL_GPIBITMAPS
#define INCL_GPIPRIMITIVES
#define INCL_DOSMISC
#define INCL_DOSPROCESS
#define INCL_DOSMODULEMGR
#define INCL_DOSSEMAPHORES
#define INCL_DOSERRORS

#include <os2.h>


#include <process.h>
#include <string.h>


typedef struct _WINDOWDATA
{
   USHORT cb;
   HBITMAP hbmCanvas;
   HDC hdcCanvas;
//   HPS hpsCanvas;
   SHORT cx;
   SHORT cy;
   HEV hevInitComplete;
}WINDOWDATA, *PWINDOWDATA;


HPS hpsCanvas = NULLHANDLE;

static void _Optlink pmThread(void *param);
static MRESULT EXPENTRY CanvasWndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2);
static void _Optlink process_create(HWND hWnd, PWINDOWDATA pwd);
static void _Optlink process_paint(HWND hWnd);



void OS2_init_povray(int argc, char **argv)
{
//   WinInitialize(0);
}

void OS2_finish_povray(int status)
{
}




void OS2_Display_Init(int w, int h)
{
   PWINDOWDATA pwd = NULL;

   DosAllocMem((PPVOID)&pwd, sizeof(WINDOWDATA), PAG_READ | PAG_WRITE | PAG_COMMIT);
   memset(pwd, 0, sizeof(WINDOWDATA));

   DosCreateEventSem(NULL, &pwd->hevInitComplete, DC_SEM_SHARED, FALSE);
   pwd->cb = sizeof(WINDOWDATA);
   pwd->cx = w;
   pwd->cy = h;

//   _beginthread(pmThread, NULL, 32768, pwd);

//   DosWaitEventSem(pwd->hevInitComplete, 10000);

   DosCloseEventSem(pwd->hevInitComplete);
   pwd->hevInitComplete = NULLHANDLE;
}

void OS2_Display_Finished(void)
{
}

void OS2_Display_Close(void)
{
}

void OS2_Display_Plot(int x, int y, unsigned char r, unsigned char g, unsigned char b)
{
   LINEBUNDLE lb;
   POINTL ptl = { x, y };
   RECTL rclInvalidate = { x, y, x+1, y+1 };

   lb.lColor = (0 * 16777216) + (r * 65536) + (g * 256) + b;

   if(hpsCanvas)
   {
      GpiSetAttrs(hpsCanvas, PRIM_LINE, LBB_COLOR, 0, &lb);

      GpiSetPel(hpsCanvas, &ptl);
   }
//   WinInvalidateRect(hwndCanvas, &rclInvalidate, FALSE);
}

void OS2_Display_Plot_Rect(int x1, int x2, int y1, int y2, unsigned char r, unsigned char g, unsigned char b)
{

}

void box(int x1, int x2, int y1, int y2, unsigned int r, unsigned int g, unsigned int b)
{
}





static void createBitmap(HAB hAB, PWINDOWDATA pwd)
{
   BITMAPINFOHEADER2 bmih2;
   SIZEL  sizl = { 0, 0 };
   DEVOPENSTRUC dop = { NULL, "DISPLAY", NULL, NULL, NULL, NULL, NULL, NULL, NULL };
   APIRET rc = NO_ERROR;

   pwd->hdcCanvas = DevOpenDC(hAB, OD_MEMORY, "*", 3L, (PDEVOPENDATA)&dop, NULLHANDLE);

   sizl.cx = sizl.cy = 1L;
   if(pwd->hdcCanvas != NULLHANDLE)
      hpsCanvas = GpiCreatePS(hAB, pwd->hdcCanvas, &sizl, PU_PELS | GPIA_ASSOC | GPIT_MICRO);

   if(hpsCanvas)
   {
      memset(&bmih2, 0, sizeof(bmih2));

      bmih2.cbFix = sizeof(bmih2);
      bmih2.cx = pwd->cx;
      bmih2.cy = pwd->cy;
      bmih2.cPlanes = 1;
      bmih2.cBitCount = 24;

      pwd->hbmCanvas = GpiCreateBitmap(hpsCanvas, &bmih2, 0, NULL, NULL);
   }
   if(pwd->hbmCanvas != GPI_ERROR)
   {
      GpiSetBitmap(hpsCanvas, pwd->hbmCanvas);
   }
}


static void _Optlink pmThread(void *param)
{
   PWINDOWDATA pwd = (PWINDOWDATA)param;
   HAB hAB = NULLHANDLE;
   HMQ hMQ = NULLHANDLE;

   hAB = WinInitialize(0);

   if(hAB)
      hMQ = WinCreateMsgQueue(hAB, 0);

   if(hMQ)
   {
      HWND hwndFrame = NULLHANDLE;
      HWND hwndCanvas = NULLHANDLE;
      FRAMECDATA fcd;

      WinRegisterClass(hAB, "PovrayCanvas", CanvasWndProc, CS_SIZEREDRAW, sizeof(PWINDOWDATA));

      fcd.cb = sizeof(fcd);
      fcd.flCreateFlags = FCF_SHELLPOSITION | FCF_SIZEBORDER | FCF_TASKLIST | FCF_TITLEBAR | FCF_SYSMENU | FCF_MINMAX;
      fcd.idResources = 100;
      fcd.hmodResources = NULLHANDLE;

      hwndFrame = WinCreateWindow(HWND_DESKTOP, WC_FRAME, "Povray/2 3.1e", WS_VISIBLE, 0, 0, 0, 0, NULLHANDLE, HWND_TOP, fcd.idResources, &fcd, NULL);

      if(hwndFrame)
         hwndCanvas = WinCreateWindow(hwndFrame, "PovrayCanvas", NULL, WS_VISIBLE, 0, 0, 0, 0, hwndFrame, HWND_TOP, FID_CLIENT, pwd, NULL);

      if(hwndCanvas)
      {
         QMSG qmsg;

         while(WinGetMsg(hAB, &qmsg, NULLHANDLE, 0UL, 0UL))
            WinDispatchMsg(hAB, &qmsg);
      }

      if(hwndFrame)
         WinDestroyWindow(hwndFrame);

      WinDestroyMsgQueue(hMQ);
   }

   if(hAB)
      WinTerminate(hAB);

   _endthread();
}


static MRESULT EXPENTRY CanvasWndProc(HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   MRESULT mReturn = 0;
   BOOL fHandled = FALSE;

   switch(msg)
   {
      case WM_CREATE:
         process_create(hWnd, mp1);
         break;

      case WM_PAINT:
         process_paint(hWnd);
         break;

      default:
         fHandled = FALSE;
         break;
   }
   if(!fHandled)
      mReturn = WinDefWindowProc(hWnd, msg, mp1, mp2);

   return mReturn;
}


static void _Optlink process_create(HWND hWnd, PWINDOWDATA pwd)
{
   WinAlarm(HWND_DESKTOP, WA_NOTE);
   createBitmap(WinQueryAnchorBlock(hWnd), pwd);

   DosPostEventSem(pwd->hevInitComplete);
}

/*
 * Scale image?
 */
static void _Optlink process_paint(HWND hWnd)
{
   PWINDOWDATA pwd = (PWINDOWDATA)WinQueryWindowPtr(hWnd, 0);
   POINTL aptl[3] = { { 0, 0 }, { pwd->cx, pwd->cy }, 0, 0 };
   HPS hPS = NULLHANDLE;

   hPS = WinBeginPaint(hWnd, NULLHANDLE, NULL);

   GpiBitBlt(hPS, hpsCanvas, 3L, aptl, ROP_SRCCOPY, BBO_IGNORE);

   WinEndPaint(hPS);
}
